<?php
/**
* フォームを生成するファクトリクラス
*
* PHP version 5
*
* @package    core
* @author     stk2k <stk2k@sazysoft.com>
* @copyright  2008 stk2k, sazysoft
*/

class charcoal_FormFactory 
{
	/*
	 * フォームを作成
	 */
	public static function create( $form_name )
	{
		log_info( "system",  "フォーム[$form_name]をロードします。", __FILE__, __LINE__ );

		// FormConfigをロード
		$config = charcoal_ConfigLoader::loadConfig( $form_name, "form" );

		// クラス名を取得
		$class_name = $config->getString( 'class_name' );

		// フォームのインスタンス生成
		$form = charcoal_ClassUtil::newInstance( $class_name );

		// 生成したインスタンスがIformインタフェースを実装しているか確認
		if ( !($form instanceof charcoal_IForm) ){
			// 実装例外
			throw new charcoal_InterfaceImplementException( $class_name, "charcoal_IForm" );
		}

		log_info( "system",  "フォーム[$form_name]を初期化します。", __FILE__, __LINE__ );

		// フォームを初期化
		$form->init( $config );

		log_info( "system",  "フォーム[$form_name]をロードしました。", __FILE__, __LINE__ );

		// ロードしたフォームを返却
		return $form;
	}
}
